<template>
  <div :class="{'node-detail-component': true, 'active': modelValue !== null}">
    <div v-if="modelValue">
      <h2>{{ title }}</h2>
      <div class="mb-2rem">
        <span v-for="label in modelValue.labels" :class="`label ${label} mr-05rem`" :key="label">
          {{ label }}
        </span>
      </div>
      <div class="mb-2rem" v-if="folders">
        <div class="mb-05rem">
          <b>Folder</b>
        </div>
        <span v-for="folder in folders" :key="folder" class="folder mr-05rem">
          {{ folder }}
        </span>
      </div>
      <div class="mb-2rem">
        <div class="mb-1rem">
          <b>Properties</b>
        </div>
        <div class="table-holder">
          <table>
            <tr v-for="(value, property) in modelValue.properties" :key="value">
              <td>{{ property }}</td>
              <td>{{ value }}</td>
            </tr>
          </table>
        </div>
      </div>
      <button @click="openMail" v-if="isMail()" class="mb-1rem">Open Mail</button>
      <button @click="close">Close</button>
    </div>
  </div>
</template>

<script lang="ts">
import {defineComponent} from "vue";
import axios from "axios";
import {api} from "@/typescript/api";

export default defineComponent({
  props: ["modelValue"],
  data() {
    return {
      mailDirectory: null as null | string,
    }
  },
  watch: {
    modelValue() {
      if (this.modelValue !== null) {
        this.loadAdditionalConfig()
      }
    }
  },
  computed: {
    title() {

      if (this.isMail()) {
        return this.modelValue.properties.subject
      }
      return this.modelValue.properties.name
    },
    folders() {
      if(!this.isMail() || !this.mailDirectory){
        return
      }

      const path = this.modelValue.properties.file_name
      let folders: string[] = path.replace(this.mailDirectory, "").replace(/^\/|\/$/g, '').split("/")

      // remove file name
      folders.pop()

      // remove all number folders
      folders = folders.filter((folder: string) => !folder.match(/^\d+$/))

      // remove any of the following basic folders
      const basic = ['Data', 'Messages']
      folders = folders.filter((folder: string) => !basic.includes(folder))

      // remove .mbox extension
      folders = folders.map((folder: string) => folder.replace(/\.mbox$/, ''))

      // remove any folders with format 'F09806D4-95ED-407E-92C7-ADDB04827D37'
      folders = folders.filter((folder: string) => !folder.match(/^[A-Z0-9]{8}-([A-Z0-9]{4}-){3}[A-Z0-9]{12}$/))

      return folders
    }
  },
  methods: {
    /**
     * Fetches and renders additional data.
     */
    async loadAdditionalConfig() {
      if (!this.mailDirectory) {
        this.mailDirectory = await api.getMailDirectory()
      }
    },

    /**
     * Returns whether node is a mail or not.
     */
    isMail() {
      return this.modelValue.labels.indexOf("Mail") > -1
    },

    /**
     * Opens a mail.
     */
    openMail() {
      if (!this.isMail()) {
        return
      }

      api.openMail(this.modelValue.properties.file_name)
    },

    /**
     * Removes the selected node which closes the pane.
     *
     */
    close() {
      this.$emit('update:modelValue', null)
    }
  }
})
</script>

<style lang="scss" scoped>
.node-detail-component {
  position: fixed;
  top: 0;
  left: -400px;
  width: 350px;
  height: 100vh;
  background: #ffffff;
  z-index: 2;
  padding: 2rem;
  transition: all .25s;

  &.active {
    left: 0;
  }

  h2 {
    margin-bottom: .5rem;
  }

  div {

    span.label {
      display: inline-block;
      background: #dfdfdf;
      padding: .3rem 1rem;
      border-radius: var(--border-radius);
      font-size: .85rem;
      font-weight: bold;

      &.Domain {
        background: #ff7f0e;
        color: #ffffff;
      }

      &.User {
        background: #1f77b4;
        color: #ffffff;
      }

      &.Mail {
        background: #2ca02c;
        color: #ffffff;
      }
    }

    span.folder {
      display: inline-block;
      background: #f3f3f3;
      padding: .3rem 1rem;
      border-radius: var(--border-radius);
      font-size: .85rem;
    }

    div.table-holder {
      overflow: auto;

      table {
        width: 100%;
        font-size: .85rem;
        overflow: scroll;
        border-collapse: collapse;
        border-radius: var(--border-radius);
        overflow: hidden;

        tr {

          &:nth-of-type(odd) {
            background: #e6e6e6;
          }

          &:nth-of-type(even) {
            background: #f1f1f1;
          }

          td {
            padding: .45rem;
          }

          td:first-child {
            font-weight: bold;

          }
        }
      }
    }
  }

}
</style>